/*
 * Advertised objects extracted from source code
 */

#define advertise         extern
#define DefaultsTo(x)     = x
#define InitializeWith(x) 

// from main.C:

advertise char *ipe_version;
advertise Display *display;
advertise int screen_num;
advertise void sel_mode(Object_type t);

// from colors.C:

advertise IColor sys_color[COL_LAST];
advertise void set_color(short idx);
advertise void write_mask(unsigned long idx);
advertise void fill_color_field(Widget field);
advertise void get_ipe_colormap(Arg &arg, int &ac);
advertise void initialize_ipe_colors(void);
advertise void allocate_colors(int num, char *names[], unsigned long pixel[]);

// from data.C:

advertise Boolean monochrome;
advertise int mipe_mode;
advertise int delta_alpha_choice;
advertise int linestyle_choice;
advertise int line_width_choice;
advertise int arrow_type;
advertise int font_choice[2];
advertise int fontsize_choice[2];
advertise int current_color[2];
advertise int grid_size_choice;
advertise Boolean grid_visible;
advertise s_coord select_distance;
advertise s_coord snap_distance;
advertise s_coord arrow_size[2];
advertise s_coord mark_size[2];
advertise short_rr     linestyle_list;
advertise s_coordreray line_width_list;
advertise s_coordreray grid_size_list;
advertise s_coordreray delta_alpha_list;
advertise s_coordreray fontsize_list[2];
advertise charp_rr	ium_directory;
advertise int		page_number;
advertise Groupp_rr	pages;
advertise Group		*cut_page;
advertise Group *pic;
advertise Iobject *curobj;
advertise Boolean edit_object;
advertise Iobject *saved_curobj;
advertise Drawing_mode drawing_mode;
advertise Iobject *cut_buffer;
advertise pl_vec canvas_origin;
advertise pl_vec canvas_pan;
advertise s_coord zoom_factor;
advertise pl_vec screen_factor;
advertise pl_vec curmp;
advertise Boolean fixpoint_set;
advertise pl_vec fixpoint;
advertise pl_angle axis_dir;
advertise pl_vec snap_base;
advertise long max_nvertex;
advertise Boolean gs_lostsync;
advertise char		filename[MAX_FILENAME_LENGTH];
advertise char		newfilename[MAX_FILENAME_LENGTH];
advertise char_rr	new_pspreamble;
advertise char_rr	new_latexpreamble;
advertise Boolean	use_new_preamble;
advertise Boolean	ps_in_defd[MAX_NUM_FIELDS];
advertise s_coord	ps_in_value[MAX_NUM_FIELDS];
advertise pl_vecreray	ps_in_array;
advertise char_rr	ps_in_string;
advertise float		ps_in_color[2][3];
advertise Transform	ps_in_transform;
advertise Boolean	ps_okay;
advertise Boolean	text_objects_saved;
advertise pl_vec	save_offset;

// from icon.C:

advertise void create_penguin(Widget icon);

// from graphics.C:

advertise GC canvas_gc, popup_gc, current_gc;
advertise Drawable drawable;
advertise XGCValues xgcvalues;
advertise void initialize_graphics(void);
advertise void resize_canvas(void);
advertise void def_linestyle(short ls, char *);
advertise short linestyle_index(short ls);

// from fonts.C:

advertise void draw_string(const pl_vec& p, // drawing position
			   short font,	    // Font style
			   s_coord size,	    // Font size
			   int curspos,	    // cursor position (-1 = none)
			   char_rr str,		
			   Boolean parbox);
advertise void get_string_size(char_rr &str,
			       int startpos, int endpos,
			       short font, s_coord size,
			       s_coord &width, s_coord &height,
			       s_coord &depth);
advertise void draw_string(const pl_vec& p, // drawing position
			   short font,	    // Font style
			   s_coord size,	    // Font size
			   int curspos,	    // cursor position (-1 = none)
			   char_rr str,		
			   Boolean parbox);
advertise void get_string_size(char_rr &str,
			       int startpos, int endpos,
			       short font, s_coord size,
			       s_coord &width, s_coord &height,
			       s_coord &depth);
advertise s_coord get_substring_width(char_rr &str,
				    int startpos, int endpos,
				    short font, s_coord size);
advertise int mouse_position(char_rr &str, const pl_vec& offs,
			     short font, s_coord size);

// from callback.C:

advertise void object_type_cb(IpeButton *button);
advertise void zoom_cb(Widget, XtPointer client_data, XtPointer);
advertise void text_choice_cb(ChoiceArgs choice);
advertise void line_choice_cb(ChoiceArgs choice);
advertise void line_arrow_cb(IpeButton *);

// from interface.C:

advertise Widget topLevel;
advertise IpeButton snap_vertex_bt, snap_boundary_bt, snap_crossing_bt;
advertise IpeButton snap_grid_bt, snap_directional_bt, snap_autodir_bt;
advertise IpeButton snap_self_bt;
advertise IpeButton transparent_bt;
advertise IpeButton left_arrow_bt, right_arrow_bt;
advertise IpeButton object_type_button[NUM_OBJECT_TYPES];
advertise Widget create_choice(Widget parent, ChoiceArgs choice,
			       char *name, IpeChoiceCallback cb,
			       int *choice_adr);
advertise Widget add_to_choice(char *label);
advertise void set_choice(Widget choice, Widget button);
advertise void manage_variant(Widget widget);
advertise void put_msg(char *str);
advertise void show_filename(void);
advertise void show_pagenum(void);
advertise void show_zoom(void);
advertise void show_m_ipe(void);
advertise void show_operation(const char *op, const char *key);
advertise void create_widgets(void);
advertise void show_message(char *str1, char *str2);
advertise void show_choice(char *str,
		 char *but1, IpeCallback call1,
		 char *but2, IpeCallback call2,
		 char *but3, IpeCallback call3);
advertise void show_file_selector(char *str, IpeStringCallback callback);
advertise void refresh_display(void);
advertise void install_colormap(void);

// from menus.C:

advertise IpeOperation_rr ipe_operation;
advertise void hide_page_menu(void);
advertise void show_page_menu(void);
advertise void add_menu_separator(Menus m);
advertise void add_menu_button(Menus m);
advertise void fill_menu_bar(Widget menuBar);

// from configuration.C:

advertise IpeButton enable_undo_bt, enable_latex_box_bt, enable_fifi_bt;
advertise IpeButton enable_interior_bt, enable_zoom_pan_bt, enable_stroke_bt;
advertise IpeButton enable_3_spline_bt;
advertise void set_ps_preamble(char *s);
advertise char *get_preamble(int which DefaultsTo(0));
advertise char *get_command(int which);
advertise void show_m_ipe_configuration(void);
advertise void show_configuration_window(void);
advertise void create_configuration_window(void);

// from resources.C:

advertise XtAppContext app_context;
advertise AppData app;
advertise char *load_options_and_resources(int *pargc, char **argv);

// from mexplain.C:

advertise void show_mouse_msg(void);
advertise void mouse_msg(char *left, char *mid, char *right);
advertise void blank_mouse_msg(void);
advertise void standard_mouse_msg(void);
advertise void fill_mouse_explainer(Widget frame);

// from operations.C:

advertise void zoom_op(int zf);
advertise void pan_op(int);
advertise void find_file(char *fn);
advertise void insert_file(char *fn, Boolean movable DefaultsTo(TRUE));
advertise void file_function(int arg);
advertise void align_function(int arg);
advertise void misc_function(int arg);
advertise void struc_function(int arg);
advertise void page_function(int iarg);
advertise void ipe_op_exec(int i);
advertise void shortcut(unsigned char key);

// from ium.C:

advertise void ium_operation(const IumDescription &ium);
advertise void decode_iums(char *iums);
advertise void create_ium_parameter_windows(void);

// from canvas.C:

advertise KeyState key_state;
advertise Widget canvasWidget;
advertise Window canvas_window;
advertise XPoint canvas_size;
advertise void canvas(short cidx);
advertise void nonidle(Drawing_mode m);
advertise void idlefy(int how);
advertise pl_vec get_mouse(s_coord mx, s_coord my);
advertise pl_vec get_mouse(void);
advertise void create_canvas_widget(Widget frame);
advertise void install_gl_interface(void);
advertise void create_canvas_widget(Widget frame);
advertise void redraw_canvas(void);
advertise void redraw_pup(void);

// from snapping.C:

advertise void draw_grid(void);
advertise void simple_snap(pl_vec& mp);
advertise void snap(pl_vec& mp);
advertise void fixpoint_op(int arg);
advertise void draw_fixpoint(void);

// from selecting.C:

advertise void clear_selection(void);
advertise void find_new_primary(void);
advertise Iobject *selection(void);
advertise void dragging_redraw(void);
advertise void selecting_push(pl_vec &mousep, Boolean shft, Boolean ctl);
advertise void selecting_key(void);
advertise void selecting_mouse(const pl_vec &mousep);
advertise void dragging_mouse(const pl_vec &mousep);
advertise void selecting_done(void);
advertise void dragging_done(const pl_vec& mp);
advertise void redraw_selection(void);

// from moving.C:

advertise void moving_redraw(void);
advertise void moving_push(pl_vec &mousep, Boolean shft, Boolean ctl, char key);
advertise void moving_mouse(const pl_vec &mousep);
advertise void moving_done(pl_vec &mousep);
advertise void move_for_paste(void);
advertise void paste_selection(void);

// from preview.C:

advertise void gs_show(void);
advertise void preview_picture(Boolean printflag, Boolean all_pages);
advertise void gs_kill(void);
advertise void parm_noundo_cb(void *, long);
advertise void cleanup_preview(void);
advertise void show_properties(void);
advertise Boolean latex_box(const char *bstr,
			    const char_rr& dstr, const char *fstr,
			    s_coord& wd, s_coord& ht, s_coord& dp);
advertise char *search_a_ium(char *ium_name);
advertise void call_ium(char *exec, char *ium_arg,
			unsigned long flags, char *ium_parm);
advertise void kill_ium(void);
advertise void signal_setup(void);

// from transform.C:


// from postscript.C:


// from struc.C:

advertise void ungroup_selection(void);
advertise void make_selection_list(Iobject*& nf, Iobject*& nl);
advertise void front_selection(void);
advertise void back_selection(void);
advertise void group_selection(void);
advertise void select_all(Boolean fixed_type);
advertise void cut_selection(Boolean save);
advertise void copy_selection(void);
advertise void duplicate_selection(void);
advertise void object_added(void);
advertise void undo_init(void);
advertise void undo_reset(Boolean fresh DefaultsTo(TRUE) );
advertise void undo_operation(void);
advertise Boolean undo_p(void);
advertise void undo_changed(void);
advertise void undo_new_page(void);
advertise void maybe_turnoff_undo(void);

// from file.C:

advertise Boolean ps_save_picture(IpeCallback callback);
advertise Boolean ps_save_picture(char *fn DefaultsTo(filename),
				  int pagenum DefaultsTo(0),
				  Boolean force DefaultsTo(TRUE),
				  IpeCallback callback DefaultsTo(NIL));
advertise char *ps_read_next(istream& fh);
advertise Boolean ps_read_entry(istream& fh, int num, char **fields);
advertise int ps_read_file(char *fn, Group* &gr);

// from line.C:

advertise void draw_arrow(const pl_vec& from, const pl_vec& to, s_coord size);
advertise void snap_edge(const pl_vec& mp, pl_vec& p, const pl_edge& e);

// from text.C:

advertise int text_variant InitializeWith(0);
advertise void create_text_variants(Widget parent);
advertise void textmode_op(int parbox);

// from group.C:

advertise void pic_traverse(Object_type t, void (*pfunc)(Iobject*));

// from circle.C:

advertise int circle_variant;
advertise void create_circle_variants(Widget parent);

// from box.C:

advertise int box_variant InitializeWith(0);
advertise void create_box_variants(Widget parent);

// from mark.C:

advertise int mark_variant;
advertise void create_mark_variants(Widget parent);

// from spline.C:


// from arc.C:

advertise int arc_variant;
advertise void create_arc_variants(Widget parent);

// from bitmap.C:

advertise int write_raw_bitmaps InitializeWith(0);
advertise void ps_read_bitmap(istream& fh);

// from segments.C:

advertise void ungroup_segments(void);
advertise Boolean group_is_segments(Iobject *ob);

// from property.C:

advertise void show_property_window(char *fname);
advertise void create_property_window(void);

// Definitions for main code:

#undef advertise
#undef DefaultsTo
#undef InitializeWith

#define advertise         
#define DefaultsTo(x)     
#define InitializeWith(x) = x

